﻿# Навігація за відступами (NVDA IndentNav)  
Цей додаток дозволяє користувачам NVDA здійснювати навігацію за рівнем відступу або зміщенням рядків.
Під час редагування вихідного коду на багатьох мовах програмування, додаток дає можливість переходити між рядками одного рівня відступу, а також швидко знаходити рядки з більшим чи меншим рівнем відступу.
Аналогічні клавішні команди можна також використовувати в ієрархічних деревах.

Зверніть увагу, що починаючи з версії 1.5 (січень 2019 року) додаток IndentNav більше не працює у браузерах. Функція навігації у браузері була випущена як ще одна [надбудова BrowserNav](https://github.com/mltony/nvda-browser-nav), яку потрібно встановлювати окремо.

## Завантаження
* Поточна стабільна версія (лише для Python 3, потребує NVDA 2019.3 або новішу версію): [IndentNav](https://github.com/mltony/nvda-indent-nav/releases/latest/download/IndentNav.nvda-addon)
* Остання версія для Python 2 (сумісна з NVDA 2019.2 та більш ранніми версіями): [IndentNav v1.6](https://github.com/mltony/nvda-indent-nav/releases/download/v1.6/IndentNav-1.6.nvda-addon).

## Використання
Додаток IndentNav може бути корисним для редагування вихідного коду на багатьох мовах програмування. 
Такі мови, як Python, вимагають дотримання правильних відступів у вихідному коді, тоді як у багатьох інших мовах програмування це настійно рекомендується.
Використовуючи IndentNav ви можете натиснути NVDA+Alt+ стрілка вниз або стрілка вгору, щоб перейти до наступного або попереднього рядка з однаковим рівнем відступу.
Ви також можете натиснути NVDA+Alt+ стрілка вліво, щоб перейти до батьківського рядка, тобто попереднього рядка з меншим рівнем відступу.
Таким чином у Python ви можете легко знайти визначення поточної функції або класу.
Аналогічно ви можете натиснути NVDA+Alt+ стрілка вправо, щоб перейти до першого дочірнього елемента поточного рядка, тобто наступного рядка з більшим рівнем відступу.

Якщо ваша NVDA налаштована на вираження відступу рядків як звукових сигналів, тоді IndentNav швидко відтворить сигнали всіх пропущених рядків.
В іншому випадку він буде лише потріскувати, щоб приблизно позначити кількість пропущених рядків.

IndentNav також можна використовувати при навігації ієрархічними деревами.

Клавіатурні команди:

* NVDA+Alt+ стрілка вгору або стрілка вниз: Перехід до попереднього або наступного рядка з однаковим рівнем відступу в поточному блоці відступу.
* NVDA+Alt+Control+ стрілка вгору або стрілка вниз: Форсований перехід до попереднього або наступного рядка з однаковим рівнем відступу. Ця команда дозволяє переходити до інших блоків з відступом (наприклад, до інших функцій Python), якщо це необхідно.
* NVDA+Alt+Shift+ стрілка вгору або стрілка вниз: Перехід до першого або останнього рядка з однаковим рівнем відступу в поточному блоці відступу.
* NVDA+alt+ стрілка вліво: Перейти до батьківського рядка - це попередній рядок із меншим рівнем відступу.
* NVDA+control+alt+ стрілка вліво: Перейти до наступного батьківського рядка - тобто наступного рядка з меншим рівнем відступу.
* NVDA+Alt+ стрілка вправо: Перейти до першого дочірнього рядка - це наступний рядок із більшим рівнем відступу в тому самому блоці відступу.
* NVDA+control+Alt+ стрілка вправо: Перехід до попереднього дочірнього рядка - тобто попереднього рядка з більшим рівнем відступу в тому самому блоці відступу.
* NVDA+I: Оголошення вмісту батьківського рядка, без переміщення курсора до нього. Натисніть двічі або декілька разів, щоб уточнити батьківський рядок другого або більш високого рівня.
* NVDA+control+I: Виділення поточного блоку відступу. Натисніть двічі, щоб скопіювати в буфер обміну.
* NVDA+Alt+I: Виділення поточного блоку відступу та всіх наступних блокив відступу на одному рівні. Натисніть двічі, щоб скопіювати в буфер обміну.

## Відомі проблеми
* IndentNav наразі не підтримує VSCode. Через свою внутрішню оптимізацію VSCode не завантажує весь документ в редагований елемент керування, що унеможливлює пошук рядків далеко від поточного рядка.  
  Будь-ласка, використовуйте натомість [IndentNav розширення для VSCode](https://github.com/mltony/vscode-indent-nav/).
  Або ж, будь-ласка, розгляньте можливість використання замість цього - інше VSCode розширення [Indentation Level Movement (зміщення рівня відступу)](https://marketplace.visualstudio.com/items?itemName=kaiwood.indentation-level-movement).
* Експериментальна підтримка VSCode була додана у гілку vscode, але на даний момент вона працює недостатньо добре.

## Вихідний код
Вихідний код доступний за посиланням <http://github.com/mltony/nvda-indent-nav>.
